Loading...
Searching...
No Matches
Sip_refer_sub

## Data Structures

struct | sip_refer_sub_s
| Structure for Refer-Sub header. More...

## Macros

#define | sip_refer_sub(sip)
| Access a SIP Refer-Sub header structure sip_refer_sub_t from sip_t.
#define | SIP_REFER_SUB_INIT()
| Initializer for structure sip_refer_sub_t.
#define | SIPTAG_REFER_SUB(x)
| Tag list item for pointer to a Refer-Sub header structure sip_refer_sub_t.
#define | SIPTAG_REFER_SUB_REF(x)
| Tag list item for reference to a Refer-Sub header pointer.
#define | SIPTAG_REFER_SUB_STR(s)
| Tag list item for string with Refer-Sub header value.
#define | SIPTAG_REFER_SUB_STR_REF(x)
| Tag list item for reference to a Refer-Sub header string.

## Typedefs

typedef struct sip_refer_sub_s | sip_refer_sub_t
| @

## Functions

issize_t | sip_refer_sub_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Refer-Sub header.
issize_t | sip_refer_sub_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Refer-Sub header.
sip_refer_sub_t * | sip_refer_sub_init (sip_refer_sub_t x[1])
| Initialize a structure sip_refer_sub_t.
int | sip_is_refer_sub (sip_header_t const *header)
| Test if header object is instance of sip_refer_sub_t.
sip_refer_sub_t * | sip_refer_sub_dup (su_home_t *home, sip_refer_sub_t const *hdr))
| Duplicate a list of Refer-Sub header header structures sip_refer_sub_t.
sip_refer_sub_t * | sip_refer_sub_copy (su_home_t *home, sip_refer_sub_t const *hdr))
| Copy a list of Refer-Sub header header structures sip_refer_sub_t.
sip_refer_sub_t * | sip_refer_sub_make (su_home_t *home, char const *s))
| Make a Refer-Sub header structure sip_refer_sub_t.
sip_refer_sub_t * | sip_refer_sub_format (su_home_t *home, char const *fmt,...)))
| Make a Refer-Sub header from formatting result.

## Variables

msg_hclass_t | sip_refer_sub_class []
| Header class for Refer-Sub header.
tag_typedef_t | siptag_refer_sub
| Tag for Refer-Sub header object.
tag_typedef_t | siptag_refer_sub_str
| Tag for string with Refer-Sub header value.

## Detailed Description

## Macro Definition Documentation

## sip_refer_sub

#define sip_refer_sub | ( |  | sip | ) |

Access a SIP Refer-Sub header structure sip_refer_sub_t from sip_t.

Since
  New in
  New in 1.12.5.

## SIP_REFER_SUB_INIT

#define SIP_REFER_SUB_INIT | ( |  | ) |

Initializer for structure sip_refer_sub_t.

A static sip_refer_sub_t structure for Refer-Sub header must be initialized with the SIP_REFER_SUB_INIT() macro. For instance,

sip_refer_sub_t sip_refer_sub = SIP_REFER_SUB_INIT;
sip_refer_sub_t
struct sip_refer_sub_s sip_refer_sub_t
@
Definition sip_extra.h:49
sip_refer_sub
#define sip_refer_sub(sip)
Access a SIP Refer-Sub header structure sip_refer_sub_t from sip_t.
Definition sip_extra.h:208
SIP_REFER_SUB_INIT
#define SIP_REFER_SUB_INIT()
Initializer for structure sip_refer_sub_t.
Definition sip_extra.h:226

Since
  New in
  New in 1.12.5.

## SIPTAG_REFER_SUB

#define SIPTAG_REFER_SUB | ( |  | x | ) |

Tag list item for pointer to a Refer-Sub header structure sip_refer_sub_t.

The SIPTAG_REFER_SUB() macro is used to include a tag item with a pointer to a sip_refer_sub_t structure in a tag list.

Parameters

  x | pointer to a sip_refer_sub_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REFER_SUB_REF().

Since
  New in
  New in 1.12.5.

## SIPTAG_REFER_SUB_STR

#define SIPTAG_REFER_SUB_STR | ( |  | s | ) |

Tag list item for string with Refer-Sub header value.

The SIPTAG_REFER_SUB_STR() macro is used to include a tag item with a string containing value of a sip_refer_sub_t header in a tag list.

Parameters

  s | pointer to a string containing Refer-Sub header value, or NULL.

The string in SIPTAG_REFER_SUB_STR() can be converted to a sip_refer_sub_t header structure by giving the string s has second argument to function sip_refer_sub_make().

The corresponding tag taking reference parameter is SIPTAG_REFER_SUB_STR_REF().

Since
  New in
  New in 1.12.5.

## Typedef Documentation

## sip_refer_sub_t

typedef struct sip_refer_sub_s sip_refer_sub_t

@

SIP header field Refer-Sub is meaningful and MAY be used with a REFER request and the corresponding 2XX response only. This header field set to "false" specifies that a REFER-Issuer requests that the REFER-Recipient doesn't establish an implicit subscription and the resultant dialog.

Refer-Sub = "Refer-Sub" HCOLON refer-sub-value *(SEMI exten) refer-sub-value = "true" / "false" exten = generic-param

The parsed Refer-Sub header is stored in sip_refer_sub_t structure.

Since
  New in 1.12.5. Note that sip_t does not contain sip_refer_sub field, but sip_refer_sub() accessor function should be used for accessing Refer-Sub header structure.

See also
  RFC 4488, nua_refer(), nua_i_refer

The structure sip_refer_sub_t contains representation of Refer-Sub header.

The sip_refer_sub_t is defined as follows:

typedef struct sip_refer_sub_s
{
sip_common_t rs_common[1]; // Common fragment info
sip_error_t *rs_next; // Dummy link to next
char const *rs_value; // "true" or "false"
msg_param_t const *rs_params; // List of extension parameters
} sip_refer_sub_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_refer_sub_s
Structure for Refer-Sub header.
Definition sip_extra.h:55
sip_refer_sub_s::rs_value
char const * rs_value
"true" or "false"
Definition sip_extra.h:58
sip_refer_sub_s::rs_params
msg_param_t const * rs_params
List of extension parameters.
Definition sip_extra.h:59
sip_refer_sub_s::rs_common
sip_common_t rs_common[1]
Common fragment info.
Definition sip_extra.h:56
sip_refer_sub_s::rs_next
sip_error_t * rs_next
Dummy link to next.
Definition sip_extra.h:57

Since
  New in 1.12.5.

## Function Documentation

## sip_is_refer_sub()

int sip_is_refer_sub | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_refer_sub_t.

Check if the header class is an instance of Refer-Sub header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header refer_sub
  0 | (false) otherwise

Since
  New in
  New in 1.12.5.

## sip_refer_sub_copy()

sip_refer_sub_t * sip_refer_sub_copy | ( | su_home_t * | home,
|  | sip_refer_sub_t const * | hdr )

inline

Copy a list of Refer-Sub header header structures sip_refer_sub_t.

The function sip_refer_sub_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  refer_sub = sip_refer_sub_copy(home, sip->sip_refer_sub);
  sip_refer_sub_copy
  sip_refer_sub_t * sip_refer_sub_copy(su_home_t *home, sip_refer_sub_t const *hdr))
  Copy a list of Refer-Sub header header structures sip_refer_sub_t.
  Definition sip_extra.h:360

Returns
  A pointer to newly copied header structure, or NULL upon an error.

Since
  New in
  New in 1.12.5.

## sip_refer_sub_dup()

sip_refer_sub_t * sip_refer_sub_dup | ( | su_home_t * | home,
|  | sip_refer_sub_t const * | hdr )

inline

Duplicate a list of Refer-Sub header header structures sip_refer_sub_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  refer_sub = sip_refer_sub_dup(home, sip->sip_refer_sub);
  sip_refer_sub_dup
  sip_refer_sub_t * sip_refer_sub_dup(su_home_t *home, sip_refer_sub_t const *hdr))
  Duplicate a list of Refer-Sub header header structures sip_refer_sub_t.
  Definition sip_extra.h:316

Returns
  A pointer to the newly duplicated sip_refer_sub_t header structure, or NULL upon an error.

Since
  New in
  New in 1.12.5.

## sip_refer_sub_format()

sip_refer_sub_t * sip_refer_sub_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Refer-Sub header from formatting result.

Make a new sip_refer_sub_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_refer_sub_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

Since
  New in
  New in 1.12.5.

## sip_refer_sub_init()

sip_refer_sub_t * sip_refer_sub_init | ( | sip_refer_sub_t | x[1] | ) |

inline

Initialize a structure sip_refer_sub_t.

An sip_refer_sub_t structure for Refer-Sub header can be initialized with the sip_refer_sub_init() function/macro. For instance,

sip_refer_sub_t sip_refer_sub;
sip_refer_sub_init(&sip_refer_sub);
sip_refer_sub_init
sip_refer_sub_t * sip_refer_sub_init(sip_refer_sub_t x[1])
Initialize a structure sip_refer_sub_t.
Definition sip_extra.h:245

Since
  New in
  New in 1.12.5.

## sip_refer_sub_make()

sip_refer_sub_t * sip_refer_sub_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Refer-Sub header structure sip_refer_sub_t.

The function sip_refer_sub_make() makes a new sip_refer_sub_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_refer_sub_t header structure, or NULL upon an error.

Since
  New in
  New in 1.12.5.

## Variable Documentation

## sip_refer_sub_class

msg_hclass_t sip_refer_sub_class[]

extern

Header class for Refer-Sub header.

The header class sip_refer_sub_class defines how a SIP Refer-Sub header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_refer_sub_t header structure.

Since
  New in
  New in 1.12.5.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.